/*
    BezierCurve.cpp
    Definicija funkcija iz BezierCurve.h
*/

#include "BezierCurve.h"

int BezierCurve::elevateDegree(int degree)
{
//najveci dopusten stupanj je  100
    if(degree <= 100){
        float **new_control_points = new float*[degree+1];
        for(int i(0);i<degree+1;++i){
            new_control_points[i] = new float[3];
        }
        
        new_control_points[0][0] = controlPoints[0][0];
        new_control_points[0][1] = controlPoints[0][1];
        new_control_points[0][2] = controlPoints[0][2];
        
        new_control_points[degree][0] = controlPoints[br_tocaka-1][0];
        new_control_points[degree][1] = controlPoints[br_tocaka-1][1];
        new_control_points[degree][2] = controlPoints[br_tocaka-1][2];
        
        for(int i(1);i<degree;++i){
            new_control_points[i][0]=((float)i)/degree*controlPoints[i-1][0]+
                ((float)degree-i)/degree*controlPoints[i][0];
                
            new_control_points[i][1]=((float)i)/degree*controlPoints[i-1][1]+
                ((float)degree-i)/degree*controlPoints[i][1];
                
            new_control_points[i][2]=((float)i)/degree*controlPoints[i-1][2]+
                ((float)degree-i)/degree*controlPoints[i][2];
        }
        
        //prepisivanje u "pravo" polje
        for(int i(0);i<degree+1;++i){
            controlPoints[i][0] = new_control_points[i][0];
            controlPoints[i][1] = new_control_points[i][1];
            controlPoints[i][2] = new_control_points[i][2];
        }
        //u ostale se zapisu nule
        for(int i(degree+1);i<101;++i){
            controlPoints[i][0] = 0.0;
            controlPoints[i][1] = 0.0;
            controlPoints[i][2] = 0.0;
        }
        
        br_unesenih_tocaka = br_tocaka = degree+1;
        for(int i(0);i<degree+1;++i){
            delete [] new_control_points[i];
        }
        delete [] new_control_points;
    }
    
    return(0);    

}

int BezierCurve::decreaseDegree(int degree)
{
    if(degree > 1){
        float **new_control_points = new float*[degree+1];
        for(int i(0);i<degree+1;++i){
            new_control_points[i] = new float[3];
        }

        new_control_points[0][0] = controlPoints[0][0];
        new_control_points[0][1] = controlPoints[0][1];
        new_control_points[0][2] = controlPoints[0][2];

        new_control_points[degree][0] = controlPoints[br_tocaka-1][0];
        new_control_points[degree][1] = controlPoints[br_tocaka-1][1];
        new_control_points[degree][2] = controlPoints[br_tocaka-1][2];

        for(int i(1);i<degree;++i){
            new_control_points[i][0]=(((float)br_tocaka-1)/(br_tocaka-1-i))*(controlPoints[i][0]-
                (((float)i)/(br_tocaka-1))*new_control_points[i-1][0]);

            new_control_points[i][1]=(((float)br_tocaka-1)/(br_tocaka-1-i))*(controlPoints[i][1]-
                (((float)i)/(br_tocaka-1))*new_control_points[i-1][1]);

            new_control_points[i][2]=(((float)br_tocaka-1)/(br_tocaka-1-i))*(controlPoints[i][2]-
                (((float)i)/(br_tocaka-1))*new_control_points[i-1][2]);
        }

        //prepisivanje u "pravo" polje
        for(int i(0);i<degree+1;++i){
            controlPoints[i][0] = new_control_points[i][0];
            controlPoints[i][1] = new_control_points[i][1];
            controlPoints[i][2] = new_control_points[i][2];
        }
        //u ostale se zapisu nule
        for(int i(degree+1);i<101;++i){
            controlPoints[i][0] = 0.0;
            controlPoints[i][1] = 0.0;
            controlPoints[i][2] = 0.0;
        }

        br_unesenih_tocaka = br_tocaka = degree+1;
        for(int i(0);i<degree+1;++i){
            delete [] new_control_points[i];
        }
        delete [] new_control_points;
    }

    return(0);
    
}
